/********************************************************************************/
/* 																				*/
/*			(C) Barrett Technology Inc.											*/
/*			StandardC header		v0.1										*/
/*			Created:	10/25/95	Yoky Matsuoka								*/
/*			Edited:		02/13/96	Yoky Matsuoka	Added GoToDifferentPositions*/
/********************************************************************************/

/* all commands return error flags */
/* error flags:
	0	 everything okay
	1	 no PWR board found
	2	 no motor found
	4	 motor not initialized
	16	 couldn't reach position
	32	 unknown command
	64	 unknown parameter name
	128	 bad value
	256  tried to write read-only parameter
	512  time out
	1024 too many arguments for this command
*/                     
 
char chbuf[100], smbuf[20]; 
long delay1 = 5L, delay2 = 10L, delay3 = 15L;

/* Define motorflags */
#define kFinger1 1
#define kFinger2 2
#define kFinger3 3
#define kSpread 'S'
#define kGrasp 'G'

/* Define parameter flags */ /*read/write, readonly, writeonly*/
#define CloseVelocity    	'CV'	  /*r/w*/
#define OpenVelocity        'OV'    /*r/w*/
#define InnerGraspTorque    'IT'    /*r/w*/
#define OuterGraspTorque    'OT'    /*r/w*/
#define SpreadTorque        'ST'    /*r/w*/
#define CurrentPosition     'CP'    /*ro*/
#define MotorErrorStatus    'MS'    /*ro*/
#define MotorOnOff          'MO'    /*r/w*/
/* with strain gauge option */
#define DesiredStrainGauge  'MG'    /*wo*/
#define StrainGaugeGain     'SG'    /*r/w*/
#define CurrentStraingauge  'CG'    /*ro*/

int StrainStream(char motorflag, int duration);
int Open(char motorflag);
int Close(char motorflag);
int StepOpen(char motorflag, int stepsize);
int StepClose(char motorflag, int stepsize);
int GoToPostion(char motorflag, int position);
int GoToDifferentPositions(int pos1, int pos2, int pos3, int pos4);
int GoToHome();
int StopMotor(char motorflag, int pe);
int Set(char motorflag, char parameter_flag, int value);
int Get(char motorflag, char parameter_flag, int *value);
int Save(char motorflag);
int Load(char motorflag);
int Default(char motorflag);
int Temperature(int *temp);
int InitCommunication();
int InitSoftware();
int InitHand(); 