/*====================================================================*
 * VARS.H                                                             *
 * Header file for use with standard BA4 and BW3 programs.            *
 *                                                                    * 
 *                  1997 Barrett Technology, Inc.                     *
 *                          Karl Leeser                               *
 *====================================================================*/

#define WINDOW 2
#define SLOW_VEL 10000.0       /* slow velocity for motion */
#define SLOW_ACCEL 10000.0      /* slow acceleration for motion */

#define USUAL_VEL 10000.0       /* usual velocity for motion */
#define USUAL_ACCEL 10000.0      /* usual acceleration for motion */



#define HIGH_LIM 100000   /* some large number that software */
                          /*  limits won't reach             */
#define LOW_LIM -HIGH_LIM

#define STEP .5           /* time stuff */
#define NORMALIZER 1000.0 /* time stuff */

#define MAX_DOWNLOAD 20   /* half of max number of points in frame buffer */
                          /* 20<50 for 6 axes (6 x 50 = 300 frames) */ 
                          
#define MAX_NUMBER_POINTS 1000  /* Maximum number of allowable 7 axis,  *
 								 * user-defined points.  Maximum static *
 								 * array size.                          */

#define SLEEP_TIMEOUT 300 /* seconds till timeout */
#define SLEEP_VEL 10000.0
#define SLEEP_ACCEL 10000.0 

#define PI              (3.1415926535897262846F)
#define HALFPI          (PI / 2)
#define DEG_TO_RAD      (PI / 180)
#define RAD_TO_DEG      (180 / PI)
#define TWOPI           (2 * PI)

/*#define  CLAMP(v, l, h)  if ((v)<(l))v=(l);else if ((v)>(h))v=(h);else */
#define  CLAMP(v, l, h)  if ((v)<(l))v=(l);else if ((v)>(h))v=(h);