/*======================================================================*
 *  Module .............Btech.lib                                       *
 *  File ...............syscfg.h                                        *
 *  Author .............Karl Leeser                                     *
 *  Creation Date ......23 August 1997                                  *
 *                                                                      *
 *             Copyright (c) 1997 Barrett Technology, Inc.              *
 *                        139 Main Street                               *
 *                       Kendall/MIT Square                             *
 *                  Cambridge, MA  02142-1528  USA                      *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *                   
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  * 
 *  lost profits, or any incidental, special, or consequential damage.  *
 *                                                                      *
 *                        SUPPORTED COMPILERS                           *
 *                                                                      *
 *  This software has been compiled and tested with the following 'C'   *
 *  compilers:                                                          *
 *                                                                      *
 *  - Microsoft Visual C v1.52                                          *
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:                                                              *
 *   This file contains system configuration information for the        *
 *   Barrett Technology, Inc. motion control library.                   *
 *                                                                      *
 *  REVISION HISTORY:                                                   *
 *                                                                      *
 *======================================================================*/ 
 
/*======================================================================*
 * Define robot system:                                                 *
 *======================================================================*/
#define N_AXES 7
#define HAND FALSE

/*======================================================================*
 * Define hardware version number:                                      *
 *======================================================================*/
#define HW_DATECODE 1998.0         

/*======================================================================*
 * Theoretical transmission ratios:                                     *
 *======================================================================*/ 
// value for BA4-250 #define N1  (float)(27.81)
#define N1  (float)(35.87)
#define N2  (float)(28.21)
#define N3  N2
#define N4  (float)(17.77)
#define DIF3 (float)(1.677) /* DIF3 is the transmission ratio of the    *
							 * 3rd stage of the arm differential,       *
							 * referred to as n3 in the new             *
							 * documentation of arm transmission ratios */   
							 
#define N5	(float)10.266
#define N6	N5
#define N7	(float)14.933
#define DIF6	(float)1.0	/* DIF6 is the transmission ratio of the    *
							 * 6th stage of the arm differential,       *
							 * referred to as n6 in the new             *
							 * documentation of arm transmission ratios */   


					    