/********************************************************************/
/*             Barrett Technology Inc.                     			*/
/*             Serial.c 	v2.2                           			*/
/*			   Created:	JR  1990                           			*/
/*			   Edited:	YM	11/6/95	copied from JR         			*/  
/*						YM  12/5/95 created err_prompt_detection 	*/ 
/*						YM	12/7/95	cleaned up						*/
/********************************************************************/
			   
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "serial.h"

int  Port = 0;			/* 0 - COM1, 1 - COM2 */
static int  addr = 0x3F8;	/* 0x3f8 for com1 */
static time_t t0, t1;
static char anum;
#define WSEC   3L


int waitfrM68Bytes(int a)    
{
	 time(&t0); 
         while( (anum=CommPort(Port,1)) < (a)) {
               time(&t1); 
               if( (t1-t0)>WSEC) { 
                        fprintf(stderr, "\n M68 error: %d != %d", anum, a);
			return 0;
               } 
          }                                                                               
	return 1;          
}          

void init_serial(int port)
{        
        Port = port;
        if (Port != 0) {   
                system("mode COM2:96,n,8");
                addr = 0x2F8;
        } 
        else  { 
                system("mode COM1:96,n,8");
                addr = 0x3F8;
        }
        CommPort(Port,6);
        CommPort(Port,4);
        CommPort(Port,5);
}

void myoutp(char b) 
{
        while(1) {
                if ( (inp(addr+5) & 0x61) == 0x60) break;
                if ( (inp(addr+5) & 0x01) ) {
                        /*
                        			inp(addr);
                        			outp(addr+5, inp(addr+5)&0xFE);
                                                
                        fprintf(stderr,"\n Data read error "); */                       
                        break;
                }
                if ( (inp(addr+5) & 0x0E)) {
                        fprintf(stderr, " \n frame, overrun, parity (read) error ");
                        break;
                }
        }
        outp(addr, b);
}

/********************************************************/
/*														*/
/*    > This should be used with asynch.com,			*/
/*      which is written in an assembly language  		*/
/*														*/
/*    > COM1:  chan = 0 								*/
/*      COM2:  chan = 1 								*/
/*														*/
/*    > Operating Modes									*/
/*														*/
/*	Mode 1: # of chars in the buffer					*/
/*	Mode 2: next char in the buffer						*/
/*	Mode 4: buffer status								*/
/*	Mode 5: clears buffer								*/
/*	Mode 6: enables interrupt							*/
/*	Mode 7: disable interrupt							*/
/*	Mode 8: enable transmit on/off protocol				*/
/*	Mode 9: disable transmit on/off protocol			*/
/*	Mode 10: current status of transmit					*/
/*														*/
/********************************************************/
int CommPort(int chan, char mode)
{
        union REGS inreg, outreg;

        inreg.x.ax = mode + chan*10;
        switch (mode)
        {
        case 1: 
                int86 (0x62, &inreg, &outreg);
                return(outreg.x.ax);
                break;
        case 2: 
                int86 (0x62, &inreg, &outreg);
                return(outreg.x.ax);
                break;
        case 4: 
                int86 (0x62, &inreg, &outreg);
                return(outreg.x.ax);
                break;
        case 5: 
                int86 (0x62, &inreg, &outreg);
                return(0);
                break;
        case 6: 
                int86 (0x62, &inreg, &outreg);
                return(0);
                break;
        case 7: 
                int86 (0x62, &inreg, &outreg);
                return(0);
                break;
        case 8: 
                int86 (0x62, &inreg, &outreg);
                return(0);
                break;
        case 9:  
                int86 (0x62, &inreg, &outreg);
                return(0);
                break;
        case 10: 
                int86 (0x62, &inreg, &outreg);
                return(outreg.x.ax);
                break;
        }
        return(0);
}

void to68_char(char cc) {
        myoutp(cc);
}
void to68_uchar(unsigned char cc) {
        myoutp(cc);
}
void to68_int(int val) {
        char *ss = (char*)(&val);
        myoutp(ss[1]);
        myoutp(ss[0]);
}
void to68_long(long val) {
        char *ss = (char*)(&val);
        myoutp(ss[3]);
        myoutp(ss[2]);
        myoutp(ss[1]);
        myoutp(ss[0]);
}

void to68_string( char *ss, int n)  {
        int i;
        for (i=0; i < n; i++) {
                myoutp(ss[i]);
        }
} 

int fr68_char(char *cc) {
        if (waitfrM68Bytes(1)) {
	        *cc = readSerial();
                 return 1;
        } else return 0;
}
int fr68_uchar(unsigned char *cc) {
        if (waitfrM68Bytes(1)) {
	        *cc = readSerial();
                return 1;
	} else return 0;                
}
int fr68_int(int *val) {
        char *ss = (char*)(val);
        if ( waitfrM68Bytes(2) ) {
	        ss[1] = readSerial();			
        	ss[0] = readSerial();	
                return 1;
        }		
        return 0;
}
int fr68_uint(unsigned int *val) {
        char *ss = (char*)(val);
        if ( waitfrM68Bytes(2) ) {
	        ss[1] = readSerial();			
        	ss[0] = readSerial();			
                return 1;
	}                
        return 0;
}
int fr68_long(long *val) {
        char *ss = (char*)(val);
        if ( waitfrM68Bytes(4) ) {
        	ss[3] = readSerial();			
	        ss[2] = readSerial();			
        	ss[1] = readSerial();			
	        ss[0] = readSerial();	
                return 1;
        }		
        return 0;
}
int fr68_string( char *ss, int n)  {
        int i;
        if ( waitfrM68Bytes (n) ) {
	        for (i=0; i < n; i++) {
        	        ss[i] = readSerial(); 
	        }
        	ss[i] = '\0';
                return 1;
	}                
        return 0;
} 

/* send a character to the port */
void asiputc(int port, int c) 
{
	myoutp((char)c);
}

/*int ascii_Eterm(char mode);  */
/* send a string to the port */
void asiString(char *s) 
{
	int i, delay0=1L;
        for (i=0; s[i]; i++) {
		myoutp(s[i]); 
		delay(&delay0);
        }
        myoutp(13);
}


/*  return 1: sucessful,
	   0: timeout
*/           
int waitforPrompt()
{               
	int hand1 = 0, found = 0;
        long waittime = 182L; /* ticks */
        int cc;

	while(1) {
			flushSerial();
	         if ( checkSerial() ) {
				cc = readSerial();
	            if ( cc == '=') { 
	            	hand1 = 1;
	                }
	            else if ( cc == '>' && hand1) {
					found = 1;
					return 1;
	                } 
	            else 
	                hand1 = 0; 
                }                      
            
            if (time_out(&waittime)) {
               printf("\n time out!\n ");
               return 0; 
               }
	   }
}

int waitforAline(char *buffer)
{               
        long waittime = 182L; /* ticks */
        int cc, i=0;
        
	while(1) { 
	         if ( checkSerial() ) {
				cc = readSerial();
                if ( cc == 13 || cc==10){
                	if (i < 1) {
                		i=0; 
                		continue;
                		} 
                    else break;
                }                 
                        
                else 
                	buffer[i++] = cc;
		  	 }
                  
             if (time_out(&waittime)) {
        		buffer[i] = '\0';
                return 0; 
                }
	}
    
    buffer[i] = '\0';
	return i;
}

int err_prompt_detection()
{
	int err=0, err_track=0, prompt_track=0, i=0, cc, output[100];
	long waittime = 182L;
	flushSerial();
	while(1) {
		if(checkSerial()) {
			cc = readSerial();
			if (cc == 'E') {
				err_track = 1;
				output[i] = cc;
				i++;	
			} 
			else if ((cc == 'R') && (err_track >=1)){
				err_track++;
				output[i] = cc;
				i++;
			}            
			if (cc == '=') { 
				prompt_track = 1; 
				output[i] = cc;
				i++;
			}  
			else if ((cc == '>' ) && (prompt_track == 1)) {
				prompt_track = 2;
				output[i] = cc;
				break;
			}
			else {
				output[i] = cc;
				i++;
			} 
		}
		if (time_out(&waittime)) 
			return 512;         
	}             
	   
	if (err_track == 3) {                         	/* error was detected */ 
		for(i=0;output[i]!='\0';i++) {
			if((output[i]>=48)&&(output[i]<=57))
				err = (err*10) + (output[i] - 48);
		}
		return err;
	}
	
	else if (prompt_track == 2)                		/* prompt was detected without an error */
		return 0;
	else 
		return 512;                               	/* time out! */
}
      