/*======================================================================*
 *  Module .............WAMdemo.c                                       *
 *  File ...............WAMdemo.c                                       *
 *  Author .............Dustin Rand                                     *
 *  Creation Date ......1 July, 1998                                    *
 *                                                                      *
 *             Copyright (c) 1998 Barrett Technology, Inc.              *
 *                        139 Main Street                               *
 *                       Kendall/MIT Square                             *
 *                  Cambridge, MA  02142-1528  USA                      *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *                                                                      *
 *                        SUPPORTED COMPILERS                           *                
 *                                                                      *
 *  This software has been compiled and tested with the following 'C'   *
 *  compilers:                                                          *
 *                                                                      *
 *  - Microsoft Visual C v1.52                                          *
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:                                                              *
 *   This file contains the function definitions for the Barrett        *
 *   Technology, Inc. motion control library.                           *
 *                                                                      *
 *  REVISION HISTORY:                 									*
 *																		*
 *       980701	dr	Changed name from anu.c to WAMdemo.c            	*
 *       990525 dr  Moved all functions to btech.c                      *
 *======================================================================*/

#include "btech.h"


#define DELTA_JA 0.1 /* rad */

int ripplet[END-START][2]; 
int smth_ripplet[END-START];


void main()
{
    double n_axis_point[N_AXES]={0,HALFPI,-HALFPI,-HALFPI};
	int moAry[N_AXES]=N_AXIS_ZERO_ARY, compensate_axes;  
	int	TEST,i, axis, cycles, idx, err; 
	char key=' ', answer=' ', data=' ';       
	int mt[N_AXES]={0,0,0,0}; 
    float jtAry[N_AXES]=N_AXIS_ZERO_ARY;  
	char replay=TRUE, NewTrajectory=TRUE, list_ended=FALSE;
	int voltage=0,max_voltage=0, coordsys[N_AXES]=COORDSYS_ARY;        
	extern int list_length;
    float step_size=(float)(0.5);
    double vel=USUAL_VEL,accel=USUAL_ACCEL;
    int* fp;
    char show=FALSE, loadfail=FALSE;	
    int index,length;
	FILE *source;
	FILE *destination;  
	char sourcefile[100]=TR_PATH;
	char destinationfile[100] = TR_PATH;
    char savefilename[100];




	if(N_AXES==7)
	{
		n_axis_point[4]=0;
		n_axis_point[5]=0;			
		n_axis_point[6]=0;
	}	
	
// dr added to set safety bit high before the user runs a program
	initRobot();
    
	system("cls");
	printf("\nWelcome to WAMdemo, please choose from the following:\n\n");
	printf("Test 1:  Tests commandmovejoint() \n");
	printf("Test 2:  Sleep2().  Commands zeroG at %.0f percent.\n", (SLEEP_SCALE_FACTOR)*100);
	printf("Test 3:  awakenRobot(). Automatically finds zero position.\n");
	printf("Test 4:  DemoJoints(). Allows user to move robot to different comfingurations.\n");
	printf("Test 5:  Sleep1().  Moves arm to folded up position.\n");
	printf("Test 6:  Killrobot(). Kills the power to the cabinet\n");
	printf("Test 7:  calibrateZeroG(). calculates constants for zeroG.\n");
    printf("Test 8:  Torque ripple compensation for all motors.\n");
    printf("Test 9:  Tests the repeatablitiy of awakenRobot.\n");
    printf("Test 10: Tests Gravity Compensation with torque ripple compensation.\n");
	printf("Test 11: Teach and Play, with gravity and torque ripple compensation\n");
	printf("Test 12: Tests Hand and Arm controlled by the same program.\n");    
    printf("Test 13: Tests Gravity Compensation with holding position function.\n");
    printf("Test 14: Idles Motors.\n");
    printf("Test 15: Converts binary torque ripple data to text for viewing.\n");
    printf("Please select a test by typing the appropriate number:");
	scanf("%d", &TEST);

    switch(TEST)
    {
   
   /*-------------------------------------------------------------------------------------*
	*  Case 1 calls awaken1() robot which asks the user to move to the zero position,     *
	*	records the position and then asks the user to put the arm in a rest              *
	*	position.  It then moves the robot to a predetermined joint position defined in   *
	*	n_axis_point, testing commandmovejoint().                                         *
	*-------------------------------------------------------------------------------------*/

		case 1:   
    	
//     		initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
			
			/* defines demo position */
			n_axis_point[0]=-HALFPI;
			n_axis_point[0]=HALFPI;
			n_axis_point[0]=-HALFPI;
			n_axis_point[0]=HALFPI;
			   			
   			if(N_AXES==7)
			{
				n_axis_point[4]=HALFPI;
				n_axis_point[5]=-HALFPI;			
				n_axis_point[6]=HALFPI;
			}	
                 		
     		system("cls");
     		printf("This test will test the commandMoveJoint() function.");
    		printf("\nPress any key to begin....\n");
    		getch();
    					
			Awaken1();     
	
			printf("\nThe arm will move to:");
			for(i=0;i<N_AXES;i++) printf("\nAxis %d:\t%.2f", (i+1), n_axis_point[i]);
			printf("\n\nEnable the robot and press any key to continue.");
			
			getch();      
	        
	        enableRobot(POSITION);
			
			commandMoveJoint(n_axis_point); 
    		while(!all_done()){}  /* wait */ 
    		printf("\nMove completed.");
    		Sleep1();
    		break;
    		
  	   /*---------------------------------------------------------------------------*
 		*	Case 2 tests the sleep2 function.  this uses zero gravity at			*
 		*	SLEEP_SCALE_FACTOR percentace and will                              	*
 		*	slowly fall to the least energy state.	UNTESTED						*
		*---------------------------------------------------------------------------*/

		case 2: 
    	    /* temporarily insert break until bug with sleep2 */
    		
//    		initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
			
			
    		system("cls");
    		printf("This test will test the Sleep2() function."); 
			printf("\nThis function will command gravity compensation at %d percent.", (int)(SLEEP_SCALE_FACTOR*100));
			Awaken1();
			updateRobot(Robot);
    		enableRobot(POSITION);
    		printf("\n\nEnable Robot and press any key to begin...\n");
    		getch();
    		
    		
    		printf("The Robot will move to a semi-upright position.\n");
    		printf("Press any key to begin....");
    		getch();  
    		    		
    		n_axis_point[0]=0;
			n_axis_point[1]=(-HALFPI/2);
			n_axis_point[2]=0;
			n_axis_point[3]=0;
			
			if(N_AXES==7)
			{
				n_axis_point[4]=0;
				n_axis_point[5]=0;
				n_axis_point[6]=0;
			}    		
    		commandMoveJoint(n_axis_point);
    		while(!all_done()){};
    		
 	  		printf("\nIf the robot is in a stable position,\n"); 
    		printf("the user can push the arm to begin sleeping.\n");
     		printf("Press any key to sleep robot.\n");
    		getch();
    		
    		Sleep2(Robot); 
    		
    		break;  
    		
	/*--------------------------------------------------------------------------------------*    	
	 * Case 3 will test the awakenRobot() function.  This function attempts to zero         *
	 *	the axis automatically, by determining its workspace.  It determines it workspace	*
	 *	by moving to the extents of its workspace and calculates the middle.  This starts   *
	 *	at the outermost joint and then decreases the joints till all midpoints are found 	*
	 *  (excpet joint 4 which finds the vertical position)									*
	 *--------------------------------------------------------------------------------------*/
	
		case 3: 
//    		initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);
    		
    		system("cls");
    		printf("This will test the function awakenRobot().\n");
    		printf("\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();
    		
    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);
    		
    		printf("\n\nMake sure robot is enabled and press any key to begin....\n");
    		getch();  
			
			    		
    		/* awaken robot enables the robot, so it is not necssesary to do it here */
    		
    		awakenRobot(Robot); 
    		printf("\nRobot is in its zero position, press any key to sleep");
			getch();    		
    		Sleep1();
    		
    		break;
    		
    /*--------------------------------------------------------------------------------------*    	
	 *	 Case 4 tests the demojoints function.  this function moves the robot to different  *
	 *	 positions.  These positions are defined by the user in the demojoints function	 	*
	 *--------------------------------------------------------------------------------------*/
        
		case 4:   
    	
//    	    initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
    	    
    	    system("cls");
    	    printf("This program will test the demojoints() function.\n");
    		printf("\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();
    		
    		printf("\n\nThe Robot will begin the demojoints program.");
    		printf("\n\nEnable the Robot and press any key");
	        getch();

			awakenRobot(Robot);     
            demojoints(Robot);
            printf("\nExiting demojoints");
            Sleep1(); 
    		break;
     
    /*--------------------------------------------------------------------------------------*    	
	 *	Case 5 tests sleep1() function which moves the robot to a predetermined rest 		*
	 *	position 																			*	
     *--------------------------------------------------------------------------------------*/    	

		case 5:
//			initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
						
			system("cls");
			printf("This test will test the Sleep1() function.\n"); 
    		printf("\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();

			printf("\n\nEnable robot and press any key to begin....\n");
    		getch();
    		
			awakenRobot(Robot);     
	        printf("Press any key to sleep robot.\n");
	        getch();      
        	Sleep1();
        	break;

    /*--------------------------------------------------------------------------------------*    	
	 *	Case 6 tests the sleep4 which kill the robot with a digital signal					*
     *--------------------------------------------------------------------------------------*/    	

       	case 6:
			
//    	    initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);

			printf("This test will test Sleep4() which contains the KillRobot() function.\n"); 
			printf("Press any key to kill robot.\n");
			getch();
			
        	Sleep4(); 
        	printf("The Robot should have been shut down.  Press any key to idle motors\n");
        	getch();
        	break;
    
	/*--------------------------------------------------------------------------------------*    	
     *	Case 7 tests the calibratezerog function.  This function automatically awakens the 	*
     *	robot then moves the arm to predetermined positions.  While at these postions it 	*
     *	determines the average torque value for TORQUE_SAMPLES samples.  It then calculates *
     *	all of the constants needed for zero gravity.  Once the values have been determined *
     *	they have to be added to btech.h.  btech.lib then needs to be recompiled.			*
     *--------------------------------------------------------------------------------------*/
	   	case 7:   
    	
//    	    initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);

    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);

    	    system("cls");
    	    printf("This test will test the calibrateZeroG() function which determines the\n");
    	    printf("parameters for gravity compensation.");
    		printf("\n\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();

    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);

			printf("\n\nEnable robot and press any key to begin....\n");
	        getch();

			awakenRobot(Robot);     
	        
            calibrateZeroG(Robot);
            printf("\nPress any key to put robot in sleep position.\n");
            getch();
            Sleep1(); 
    		break;

    	
    
		
		/*------------------------------------------------------------------*
		 *	Case 8:  Finds index pulses manualy and compensates for 		*
		 *	torque ripple.  This allows the user to feel the affects of 	*
		 *	torque ripple compensation.										*		                                                             		
		 *------------------------------------------------------------------*/
		case 8:
		    
//		    initRobot();
		    setTorqueRippleMode(TRUE); 
		    makeRobot(Robot);

			/* do not compensate for the last axis, 7*/
            if(N_AXES==7) compensate_axes=N_AXES-1;
			else compensate_axes=N_AXES;
			
			system("cls");
			printf("This will test torque ripple compensation.");
			printf("\nAll motors, except motor 6, will be compensated.");
			
			
			for(axis=compensate_axes - 1;axis>=0;axis--)
			{
				set_position(axis, 0);
				moAry[axis]=manMarkerFoundOffset(axis);
			}
			setMarkerOffset(Robot, moAry);
			enableRobot(TORQUE);                
    		printf("\nEnable robot and press any key when ready.\n");
			getch();

    		system("cls");
			printf("Press <space> to stop torque ripple compensation.\n"
				   "Press 'c' to compensate for torque ripple.\n"
				   "Press 'n' for no torque ripple compensation.\n");
			key=getch();		
			while(key != ' ')
			{
				if(kbhit()) key=getch(); 
				
				if(key=='c') 
				{
					setTorqueRippleMode(TRUE);
					printf("\nTorque Ripple Mode: 	TRUE");
				}
				if(key=='n') 
				{
					setTorqueRippleMode(FALSE);
					printf("\nTorque Ripple Mode: 	FALSE");
				}
				
				setJointTorque(Robot,jtAry); 
				updateRobot(Robot);
				actuateRobot(Robot, 1, N_AXES);
				if (key!=' ') key='d';
			}
			break;
			
				    	
		
	/*------------------------------------------------------------------*
	 *	Case  9: Tests the repeatablitiy of the awakenRobot() routine	*
	 *------------------------------------------------------------------*/
		case 9: 
//    		initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);
    		
    		system("cls");
    		printf("This test will test the repeatability of the awakenRobot() routine.\n");
    		printf("\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();

    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);

    		printf("Make sure robot is enabled and press any key to begin....\n");
    		getch();  
    		
    		/* awaken robot enables the robot, so it is not necssesary to do it here */
			/* the following function is fundamentally the same program as awakeRobot*/    		
    		zeroAxisRepeatability(Robot); 
    		printf("\nThe Robot is in its zero position, press any key to sleep.\n");
			getch();    		
    		Sleep1();
    		
    		break;


	   /*-------------------------------------------------------------------*
		* 	Case 10: Gravity Compensation of Robot.  						*
	    *-------------------------------------------------------------------*/
		case 10:
		    
		    /* Initializes Robot */
//		    initRobot();
		    setTorqueRippleMode(TRUE); 
		    makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);
					    
			system("cls");
			printf("This will test the gravity compensation of the Robot with the ability.");
			printf("\nto turn torque ripple compensation ON or OFF.");
			
    		printf("\n\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();

    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);

    		printf("\nMake sure robot is enabled and press any key to begin....");
    		getch();  
		    awakenRobot(Robot);
	
		    if(getTorqueRippleMode())
		    {
		    	printf("\n\nPress any key to find index pulses.\n");
				getch();
			
				for(axis=N_AXES_GCOMP-1;axis>=0;axis--)
				{
					set_in_position(axis,INDEX_WINDOW);
					printf("\nFinding marker pulse for axis %d", axis);
					moAry[axis]=MarkerFoundOffset(axis);
					set_in_position(axis,WINDOW);
				}
				setMarkerOffset(Robot, moAry);
	        }
			
			Sleep1();
			
			enableRobot(TORQUE);                

           if(N_AXES==7)
			{
			controller_run(4);
           	controller_run(5);
          	controller_run(6);
            }
			
    		system("cls");
    		printf("Press any key when ready for gravity compensation.");
			getch();
			printf("\nPress <space> to stop gravity compensation.");
			printf("\nPress 'c' for torque ripple compensation.");
			printf("\nPress 'n' to stop torque ripple compensation.");
			printf("\nTorque Ripple Mode: 	TRUE");
									
			key='c';
			while(key != ' ')
			{
				if(kbhit())
				{
					key=getch(); 
					if(key=='c') 
					{
						setTorqueRippleMode(TRUE);
						printf("\nTorque Ripple Mode: 	TRUE");
					}
					if(key=='n') 
					{
						setTorqueRippleMode(FALSE);
						printf("\nTorque Ripple Mode: 	FALSE");
					}
				}
				updateRobot(Robot);
				compensateGravity(Robot);
				actuateRobot(Robot, (float)1.0, N_AXES_GCOMP);
				setJointTorque(Robot,jtAry); 
			}
			break;	    	

		/*------------------------------------------------------------------*
		 *	Case 11: Teach and Play.  Allows the user to teach the robot	*
		 * 	through a trajectory and have the robot repeat the trajectory	*
		 *	The teaching is done with gravity compensation and torque ripple*
		 *	compenstion.  The awakeRobot() program finds the zero position 	*
		 *  and the markerFoundOffset() finds the index pulses to determine	*
		 * 	abosolute position for torque ripple compensation.				*
		 *------------------------------------------------------------------*/
		case 11:

            /* initialize robot  ildes motors */
// 			initRobot();
    		setTorqueRippleMode(FALSE);
    		makeRobot(Robot);
			point_list=makePointList();
			
			system("cls");
    		printf("This program allows the user to \"teach\" points along"
	    		   "\na trajectory for subsequent \"playback\" by the robot.");

			/* awaken robot to find zero position for gravity compensation*/
			setupMove(SLOW_VEL,SLOW_ACCEL);
    		printf("\n\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();

    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);

    		printf("\n\nMake sure robot is enabled and press any key to begin....\n");
    		getch();  

            awakenRobot(Robot);
            /* robot is in position mode*/
			
			/* finds marker pulses for tr compensation if set*/
			if(getTorqueRippleMode())  
			{
				/*do not compensate for the last axis, 7*/
				if(N_AXES==7) compensate_axes=N_AXES-1;
				else compensate_axes=N_AXES;
				
				for(axis=compensate_axes-1;axis>=0;axis--)
				{
					set_in_position(axis,INDEX_WINDOW);
					printf("\nFinding marker pulse for axis %d\n", axis);
					moAry[axis]=MarkerFoundOffset(axis);
					set_in_position(axis,WINDOW);
				}
				setMarkerOffset(Robot, moAry);
			}

			/* moves robot to curled up position */
			Sleep1();
			
			
			while(NewTrajectory)
			{
			
				system("cls");
				/* loads trajectory if desired */
				printf("Press <o> to open a prerecorded trajectory file, any other key to continue.");
				if(getch()=='o')
				{
				    for(i=0;i<100;i++)	savefilename[i]='\0';
    				err=loadTrajectoryFile(&savefilename);
				    if(err==0) 
				    {
				    	printf("\nFile loaded successfully");
				    	loadfail=FALSE;
				    }
				    if(err==1)
				    {
				    	printf("\nFile was not loaded successfully");
            			loadfail=TRUE;
            		}
            		
            	}
				else
				{
	               	key=' ';
	            	/* records new trajectory */
	            	while(key != '1' && key != '2')
	            	{
		        		printf("\nYou have two options for recording trajectory points:\n"
								"\t(1)Capture positions manually by a pressing a key, or\n"
		       					"\t(2)Capture positions automatically by continuous sample.\n"
				       			"\nChoose an option by pressing <1> or <2>.");
						key=getch();

                		switch(key)
                		{        
							case '1':	  	/* capture positions by press of a key */
            				point_list=teachMoveManual(point_list, Robot);
	    					break;
							case '2':		/* capture positions by continuous sample every 0.5 seconds*/ 
							point_list=teachMove(point_list,step_size, Robot);
		    				break;
	   						default:
	   						system("cls");
	   						printf("\nYou have made an invalid selection.\n\n");
	   					}
	   				}
     			}        
                			


				while(replay&&!loadfail)
				{
	        		promptPlayback(&vel,&accel);

					printf("\nHow many cycles do you want?");
					scanf("%d", &cycles);
					
					setupMove(vel, accel);
	   				printf("\nPrepare for playback, press any  key to continue!\n"); 
					getch();
					
					for(i=0;i<cycles;i++)
    				{
					    printf("\nCyle number: %d\n", i);
						coordinatedMove(point_list);  
    	        	}
    	        	
    	        	printf("Press <space> for replay, any other key to end.\n");
    				key = getch();
    				if(key!=' ') replay=FALSE;     	
    			}

				system("cls");
				Sleep1();
			    
				if(!loadfail)
				{				
					printf("Press <s> to save trajectory to file or any other key to continue.\n");
					if(getch()=='s')	
					{
						for(i=0;i<100;i++)	savefilename[i]='\0';
						err=saveTrajectoryFile(&savefilename); 
				    	if(err==0) printf("\nFile written successfully");
				    	if(err==1) printf("\nFile was not written successfully");
					}
				}
								
				while(answer!='y' && answer!='n')
				{
					printf("\nDo you want to teach another trajectory?  y/n: ");
					answer=getch();
					if(answer=='n') NewTrajectory=FALSE;
					if(answer=='y')
					{
						replay=TRUE;
						destroyPointList(point_list);
						point_list=makePointList();
					}
				}

                answer=' ';  /* sets answer to space to enter the loop on a following passes*/

			}
						
			deinitRobot();
            destroyPointList(point_list);
			printf("Exiting TNP.\n");
			break;
		
		case 12:
			
//     		initRobot();
			setTorqueRippleMode(FALSE);
			makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);

			n_axis_point[0]=0;
			n_axis_point[0]=HALFPI;
			n_axis_point[0]=-HALFPI;
			n_axis_point[0]=HALFPI;
			   			
   			if(N_AXES==7)
			{
				n_axis_point[4]=0;
				n_axis_point[5]=0;			
				n_axis_point[6]=0;
			}	

			
			system("cls");     		
			printf("This will test the integration of the BarrettHand with the WAM.");
			printf("\n\nTo run hand commands <asynch.com> needs to have been executed first.\n"
    			   "If this has not been done, ctrl^c out of the program and run async.com.\n");
       		
       		printf("Press any key to begin....\n");
    		getch();
    					
			Awaken1();     
			
			printf("\nThe arm will move to:");
			for(i=0;i<N_AXES;i++) printf("\nAxis %d:\t%.2f", (i+1), n_axis_point[i]);
			printf("\nEnable robot and press any key to continue.");
			getch();      
	        enableRobot(POSITION);
			
			commandMoveJoint(n_axis_point); 
    		while(!all_done()){}  
    		printf("\nMove completed.");
    		printf("\nThe hand will now be initialized and a few commands executed, press any key");
    		getch();
			
			init_serial(0);
    		idx = InitHand();  
   			idx = Close('g');
			idx = Open('g');
			idx = Close('s');
			idx = Close('g');
       		Sleep1();
    		break;
		
	   /*-------------------------------------------------------------------*
		* 	Case 13: Gravity Compensation of Robot. with holding abilitiy	*
	    *-------------------------------------------------------------------*/

		case 13:
		    
		    /* Initializes Robot */
//		    initRobot();
		    setTorqueRippleMode(FALSE); 
		    makeRobot(Robot);
			setupMove(SLOW_VEL,SLOW_ACCEL);  
			
			/* finds zero position */
			for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);
			system("cls");
			printf("\nThis program will demonstrate gravity compensation with the ability");
			printf("\nto hold position.");
			
    		printf("\n\nVerify the robot has the inner link on the negative J2 stop and\n");
    		printf("and the wrist or outer link resting on the inner link.");
			printf("\nPress any key when robot is in starting position.");
	        getch();

    		for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);

    		printf("\nMake sure robot is enabled and press any key to begin....");
    		getch();  
			for(axis=0;axis<N_AXES;axis++)	set_position(axis, 0);
    	    awakenRobot(Robot);
	
    	    if(getTorqueRippleMode())
		    {
		    	printf("\nPress any key to find index pulses.\n");
				getch();
			
				for(axis=N_AXES_GCOMP-1;axis>=0;axis--)
				{
					set_in_position(axis,INDEX_WINDOW);
					printf("\nFinding marker pulse for axis %d", axis);
					moAry[axis]=MarkerFoundOffset(axis);
					set_in_position(axis,WINDOW);
				}
				setMarkerOffset(Robot, moAry);
	        }
			
			Sleep1();
			
			enableRobot(TORQUE);                
			
			printf("\nPress <space> to stop gravity compensation.");
			printf("\nPress 'c' for gravity compensation.");
			printf("\nPress 'h' to hold position.\n");
									
			key='c';
			while(key != ' ')
			{
				if(kbhit()) key=getch();
				if(key=='c')
				{
					enableRobot(TORQUE);
					printf("Gravity compensation\n");
				}
				while(key=='c' || !(key=='h' || key==' ')) 
				{
					setJointTorque(Robot,jtAry); 
					updateRobot(Robot);
					compensateGravity(Robot);
					actuateRobot(Robot, (float)1.0, N_AXES_GCOMP);
					if(kbhit()) key=getch();
				}

				if(key=='h')
				{
					for(axis=0;axis<N_AXES;axis++)
					{    
			    	    get_filter(axis,fp);
			    		fp[DF_OFFSET]=0;
						set_filter(axis,fp);
					}
					enableRobot(POSITION);
					printf("Hold position\n");
				}
				while(key=='h' || !(key=='c' || key==' '))
				{
				 	if(kbhit()) key=getch();
				}
				
			}
			
			printf("Sleeping Robot... \n");
			Sleep1();
			break;	    	
         
         /*-----------------------------------------------------*
          * Idles all motors									*
		  *-----------------------------------------------------*/          
         
         case 14:
		 	/* no code needs to be written, the code after the case statement will idle motors*/
		 	//dr added to clear faults then it can reset
//		 	initRobot();
		 	break;
		 
		 
		 /*************************************************************************/
		 /*  Converts binary data to text data									  */
		 /*************************************************************************/
		 
		 case 15:

 		system("cls");
 		printf("This program converts the binary torque ripple data to text.");
 		printf("\n\nFiles should be located in %s", TR_PATH);
		printf("\nWhich motor axis [0-6]?	");
		scanf("%d", &axis);
	
		if (axis<0 || axis >6)
		{
			printf("\nInvalid motor axis.");
			printf("\nWhich motor axis [0-6]?	");
			scanf("%d", &axis);			
		}
		fflush(stdin);
		printf("\nSmooth Data (s)      : Filtered torque ripple data");
		printf("\nRaw Data (r)         : Unfiltered forward and reverse torque ripple data");
		printf("\nAveraged Data (a)    : Average of the forward and reverse torque ripple data");
		printf("\nCompensated Data (c) : The actual forward and reverse torque ripple data after"
			   "\n                       being compensated\n");
		
		scanf("%c", &data);
	    if (data!='r' &&  data!='s' && data!='c' && data!='a')
		{
			printf("\nInvalid data selection.\n");
			printf("Smooth Data (s) or Raw Data (r) or Compensated Data (c)? ");
			scanf("%c", &data);			
		}
		
		switch(data)
		{
			case 'r':
				sprintf(sourcefile, "%s%s%d", TR_PATH, "raw_tr.d", axis);
				break;
			case 's':  
				sprintf(sourcefile, "%s%s%d", TR_PATH, "smth_tr.d", axis);
				break;   
			case 'c':  
				sprintf(sourcefile, "%s%s%d", TR_PATH, "comp_tr.d", axis);
				break;   

			case 'a':  
				sprintf(sourcefile, "%s%s%d", TR_PATH, "avrg_tr.d", axis);
				break;   

			default:
				printf("Unrecognized second argument to Binary.exe .\n");
				exit(0);
		}
	
		sprintf(destinationfile, "%s%s%d", TR_PATH, TR_DEST, axis);
		fflush( stdin);

    	printf("Source file: %s\n", sourcefile);
    	printf("Destination file: %s\n", destinationfile);
    	getch();

		if ((source = fopen(sourcefile, "rb")) == NULL)
		{
			printf( "Error opening file %s in this directory.\n", sourcefile );
			exit( 1 );
		}
	
		if ((destination = fopen(destinationfile, "w")) == NULL)
		{
			printf( "Error opening file %s in this directory.\n", destinationfile );
			exit( 1 );
		}
	
		printf("Opened %s.\n",sourcefile);
	
		if(data == 'r' || data == 'c')
		{
			//fread( ripplet, sizeof(ripplet), 1, source); 
			fread(ripplet, sizeof(ripplet[0]),2*TR_ARY_LENGTH, source);
			length=sizeof(ripplet)/sizeof(ripplet[0]);      
			printf("size of raw ripplet %d\n", sizeof(ripplet));
			printf("size of raw ripplet element %d\n", sizeof(ripplet[0]));

			for(index=0;index<length;index++)
			{
				/* changed %.6f to d because of change in type */	
    			fprintf(destination,"%d\t%d\t%d\n",index,ripplet[index][0],ripplet[index][1]);
    		}
		}
		else
		{
//			fread( smth_ripplet, sizeof(smth_ripplet), 1, source);
			fread(smth_ripplet, sizeof(smth_ripplet[0]), TR_ARY_LENGTH, source);
			length=sizeof(smth_ripplet)/sizeof(smth_ripplet[0]);      
			printf("length = %d\n", length);
			printf("size of smth ripplet %d\n", sizeof(smth_ripplet));
			printf("size of smth ripplet element %d\n", sizeof(smth_ripplet[0]));
			getch();
			for(index=0;index<length;index++)
			{
    		/* changed %.6f to d because of change in type */
    			fprintf(destination,"%d\t%d\n",index,smth_ripplet[index]);
//				printf("%d\t%d\n",index,smth_ripplet[index]);    			
    		}
		}  

		fclose(source);
		fclose(destination);
    
    	printf("Wrote %s.\n",destinationfile);
    	printf("Data translation complete.\n" );
		printf("Use Excel to view data.\n");
		break;
		 
		 default:
    		_error("Error...Invalid test in WAMdemo.C.\n");
    		break;
		}
	deinitRobot();
	destroyRobot(Robot); 
	 

} 





	


